Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -4625,9 +4652,9 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RC6_PROTOCOL == 1
                                 {
 #ifdef ANALYZE
-                                    ANALYZE_PUTCHAR ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '1' : '0');
+                                    ANALYZE_PUTCHAR ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '1' : '0');
 #endif // ANALYZE
-                                    irmp_store_bit ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 :   0 );
+                                    irmp_store_bit ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 :   0 );
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && IRMP_SUPPORT_RCII_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
                                     if (! irmp_param2.protocol)
@@ -4637,16 +4664,16 @@ irmp_ISR (void)
                                         ANALYZE_NEWLINE ();
 #endif // ANALYZE
                                     }
-                                    last_value = (irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 : 0;
+                                    last_value = (ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 1 : 0;
                                 }
                             }
                         }
-                        else if (irmp_pulse_time >= irmp_param.pulse_1_len_min && irmp_pulse_time <= irmp_param.pulse_1_len_max
-                                 /* && irmp_pause_time <= 2 * irmp_param.pause_1_len_max */)
+                        else if (ir->isr.pulse_time >= ir->param.pulse_1_len_min && ir->isr.pulse_time <= ir->param.pulse_1_len_max
+                                 /* && ir->isr.pause_time <= 2 * ir->param.pause_1_len_max */)
                         {
                             uint_fast8_t manchester_value;
 
-                            if (last_pause > irmp_param.pause_1_len_max && last_pause <= 2 * irmp_param.pause_1_len_max)
+                            if (last_pause > ir->param.pause_1_len_max && last_pause <= 2 * ir->param.pause_1_len_max)
                             {
                                 manchester_value = last_value ? 0 : 1;
                                 last_value  = manchester_value;
@@ -4661,7 +4688,7 @@ irmp_ISR (void)
 #endif // ANALYZE
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
-                            if (! irmp_param2.protocol)
+                            if (! ir->param2.protocol)
 #endif
                             {
 #ifdef ANALYZE
@@ -4670,17 +4697,17 @@ irmp_ISR (void)
                             }
 
 #if IRMP_SUPPORT_RC6_PROTOCOL == 1
-                            if (irmp_param.protocol == IRMP_RC6_PROTOCOL && irmp_bit == 1 && manchester_value == 1)     // RC6 mode != 0 ???
+                            if (ir->param.protocol == IRMP_RC6_PROTOCOL && ir->bit == 1 && manchester_value == 1)     // RC6 mode != 0 ???
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to RC6A protocol\n");
 #endif // ANALYZE
-                                irmp_param.complete_len = RC6_COMPLETE_DATA_LEN_LONG;
-                                irmp_param.address_offset = 5;
-                                irmp_param.address_end = irmp_param.address_offset + 15;
-                                irmp_param.command_offset = irmp_param.address_end + 1;                                 // skip 1 system bit, changes like a toggle bit
-                                irmp_param.command_end = irmp_param.command_offset + 16 - 1;
-                                irmp_tmp_address = 0;
+                                ir->param.complete_len = RC6_COMPLETE_DATA_LEN_LONG;
+                                ir->param.address_offset = 5;
+                                ir->param.address_end = ir->param.address_offset + 15;
+                                ir->param.command_offset = ir->param.address_end + 1;                                 // skip 1 system bit, changes like a toggle bit
+                                ir->param.command_end = ir->param.command_offset + 16 - 1;
+                                ir->tmp_address = 0;
                             }
 #endif // IRMP_SUPPORT_RC6_PROTOCOL == 1
 
@@ -4689,28 +4716,28 @@ irmp_ISR (void)
                         else
                         {
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && IRMP_SUPPORT_FDC_PROTOCOL == 1
-                            if (irmp_param2.protocol == IRMP_FDC_PROTOCOL &&
-                                irmp_pulse_time >= FDC_PULSE_LEN_MIN && irmp_pulse_time <= FDC_PULSE_LEN_MAX &&
-                                ((irmp_pause_time >= FDC_1_PAUSE_LEN_MIN && irmp_pause_time <= FDC_1_PAUSE_LEN_MAX) ||
-                                 (irmp_pause_time >= FDC_0_PAUSE_LEN_MIN && irmp_pause_time <= FDC_0_PAUSE_LEN_MAX)))
+                            if (ir->param2.protocol == IRMP_FDC_PROTOCOL &&
+                                ir->isr.pulse_time >= FDC_PULSE_LEN_MIN && ir->isr.pulse_time <= FDC_PULSE_LEN_MAX &&
+                                ((ir->isr.pause_time >= FDC_1_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_1_PAUSE_LEN_MAX) ||
+                                 (ir->isr.pause_time >= FDC_0_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_0_PAUSE_LEN_MAX)))
                             {
 #ifdef ANALYZE
                                 ANALYZE_PUTCHAR ('?');
 #endif // ANALYZE
-                                irmp_param.protocol = 0;                // switch to FDC, see below
+                                ir->param.protocol = 0;                // switch to FDC, see below
                             }
                             else
 #endif // IRMP_SUPPORT_FDC_PROTOCOL == 1
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && IRMP_SUPPORT_RCCAR_PROTOCOL == 1
-                            if (irmp_param2.protocol == IRMP_RCCAR_PROTOCOL &&
-                                irmp_pulse_time >= RCCAR_PULSE_LEN_MIN && irmp_pulse_time <= RCCAR_PULSE_LEN_MAX &&
-                                ((irmp_pause_time >= RCCAR_1_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_1_PAUSE_LEN_MAX) ||
-                                 (irmp_pause_time >= RCCAR_0_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_0_PAUSE_LEN_MAX)))
+                            if (ir->param2.protocol == IRMP_RCCAR_PROTOCOL &&
+                                ir->isr.pulse_time >= RCCAR_PULSE_LEN_MIN && ir->isr.pulse_time <= RCCAR_PULSE_LEN_MAX &&
+                                ((ir->isr.pause_time >= RCCAR_1_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_1_PAUSE_LEN_MAX) ||
+                                 (ir->isr.pause_time >= RCCAR_0_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_0_PAUSE_LEN_MAX)))
                             {
 #ifdef ANALYZE
                                 ANALYZE_PUTCHAR ('?');
 #endif // ANALYZE
-                                irmp_param.protocol = 0;                // switch to RCCAR, see below
+                                ir->param.protocol = 0;                // switch to RCCAR, see below
                             }
                             else
 #endif // IRMP_SUPPORT_RCCAR_PROTOCOL == 1
@@ -4718,25 +4745,25 @@ irmp_ISR (void)
 #ifdef ANALYZE
                                 ANALYZE_PUTCHAR ('?');
                                 ANALYZE_NEWLINE ();
-                                ANALYZE_PRINTF ("error 3 manchester: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                                ANALYZE_PRINTF ("error 3 manchester: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                                 ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                irmp_start_bit_detected = 0;                            // reset flags and wait for next start bit
-                                irmp_pause_time         = 0;
+                                ir->isr.start_bit_detected = 0;                            // reset flags and wait for next start bit
+                                ir->isr.pause_time         = 0;
                             }
                         }
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && IRMP_SUPPORT_FDC_PROTOCOL == 1
-                        if (irmp_param2.protocol == IRMP_FDC_PROTOCOL && irmp_pulse_time >= FDC_PULSE_LEN_MIN && irmp_pulse_time <= FDC_PULSE_LEN_MAX)
+                        if (ir->param2.protocol == IRMP_FDC_PROTOCOL && ir->isr.pulse_time >= FDC_PULSE_LEN_MIN && ir->isr.pulse_time <= FDC_PULSE_LEN_MAX)
                         {
-                            if (irmp_pause_time >= FDC_1_PAUSE_LEN_MIN && irmp_pause_time <= FDC_1_PAUSE_LEN_MAX)
+                            if (ir->isr.pause_time >= FDC_1_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_1_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("   1 (FDC)\n");
 #endif // ANALYZE
                                 irmp_store_bit2 (1);
                             }
-                            else if (irmp_pause_time >= FDC_0_PAUSE_LEN_MIN && irmp_pause_time <= FDC_0_PAUSE_LEN_MAX)
+                            else if (ir->isr.pause_time >= FDC_0_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_0_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("   0 (FDC)\n");
@@ -4744,29 +4771,29 @@ irmp_ISR (void)
                                 irmp_store_bit2 (0);
                             }
 
-                            if (! irmp_param.protocol)
+                            if (! ir->param.protocol)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to FDC protocol\n");
 #endif // ANALYZE
-                                memcpy (&irmp_param, &irmp_param2, sizeof (IRMP_PARAMETER));
-                                irmp_param2.protocol = 0;
-                                irmp_tmp_address = irmp_tmp_address2;
-                                irmp_tmp_command = irmp_tmp_command2;
+                                memcpy (&irmp.param, &irmp.param2, sizeof (IRMP_PARAMETER));
+                                ir->param2.protocol = 0;
+                                ir->tmp_address = ir->tmp_address2;
+                                ir->tmp_command = ir->tmp_command2;
                             }
                         }
 #endif // IRMP_SUPPORT_FDC_PROTOCOL == 1
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && IRMP_SUPPORT_RCCAR_PROTOCOL == 1
-                        if (irmp_param2.protocol == IRMP_RCCAR_PROTOCOL && irmp_pulse_time >= RCCAR_PULSE_LEN_MIN && irmp_pulse_time <= RCCAR_PULSE_LEN_MAX)
+                        if (ir->param2.protocol == IRMP_RCCAR_PROTOCOL && ir->isr.pulse_time >= RCCAR_PULSE_LEN_MIN && ir->isr.pulse_time <= RCCAR_PULSE_LEN_MAX)
                         {
-                            if (irmp_pause_time >= RCCAR_1_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_1_PAUSE_LEN_MAX)
+                            if (ir->isr.pause_time >= RCCAR_1_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_1_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("   1 (RCCAR)\n");
 #endif // ANALYZE
                                 irmp_store_bit2 (1);
                             }
-                            else if (irmp_pause_time >= RCCAR_0_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_0_PAUSE_LEN_MAX)
+                            else if (ir->isr.pause_time >= RCCAR_0_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_0_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("   0 (RCCAR)\n");
@@ -4774,108 +4801,108 @@ irmp_ISR (void)
                                 irmp_store_bit2 (0);
                             }
 
-                            if (! irmp_param.protocol)
+                            if (! ir->param.protocol)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to RCCAR protocol\n");
 #endif // ANALYZE
-                                memcpy (&irmp_param, &irmp_param2, sizeof (IRMP_PARAMETER));
-                                irmp_param2.protocol = 0;
-                                irmp_tmp_address = irmp_tmp_address2;
-                                irmp_tmp_command = irmp_tmp_command2;
+                                memcpy (&irmp.param, &irmp.param2, sizeof (IRMP_PARAMETER));
+                                ir->param2.protocol = 0;
+                                ir->tmp_address = ir->tmp_address2;
+                                ir->tmp_command = ir->tmp_command2;
                             }
                         }
 #endif // IRMP_SUPPORT_RCCAR_PROTOCOL == 1
 
-                        last_pause      = irmp_pause_time;
-                        wait_for_space  = 0;
+                        last_pause      = ir->isr.pause_time;
+                        ir->isr.wait_for_space  = 0;
                     }
                     else
 #endif // IRMP_SUPPORT_MANCHESTER == 1
 
 #if IRMP_SUPPORT_SERIAL == 1
-                    if (irmp_param.flags & IRMP_PARAM_FLAG_IS_SERIAL)
+                    if (ir->param.flags & IRMP_PARAM_FLAG_IS_SERIAL)
                     {
-                        while (irmp_bit < irmp_param.complete_len && irmp_pulse_time > irmp_param.pulse_1_len_max)
+                        while (ir->bit < ir->param.complete_len && ir->isr.pulse_time > ir->param.pulse_1_len_max)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('1');
 #endif // ANALYZE
                             irmp_store_bit (1);
 
-                            if (irmp_pulse_time >= irmp_param.pulse_1_len_min)
+                            if (ir->isr.pulse_time >= ir->param.pulse_1_len_min)
                             {
-                                irmp_pulse_time -= irmp_param.pulse_1_len_min;
+                                ir->isr.pulse_time -= ir->param.pulse_1_len_min;
                             }
                             else
                             {
-                                irmp_pulse_time = 0;
+                                ir->isr.pulse_time = 0;
                             }
                         }
 
-                        while (irmp_bit < irmp_param.complete_len && irmp_pause_time > irmp_param.pause_1_len_max)
+                        while (ir->bit < ir->param.complete_len && ir->isr.pause_time > ir->param.pause_1_len_max)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('0');
 #endif // ANALYZE
                             irmp_store_bit (0);
 
-                            if (irmp_pause_time >= irmp_param.pause_1_len_min)
+                            if (ir->isr.pause_time >= ir->param.pause_1_len_min)
                             {
-                                irmp_pause_time -= irmp_param.pause_1_len_min;
+                                ir->isr.pause_time -= ir->param.pause_1_len_min;
                             }
                             else
                             {
-                                irmp_pause_time = 0;
+                                ir->isr.pause_time = 0;
                             }
                         }
 #ifdef ANALYZE
                         ANALYZE_NEWLINE ();
 #endif // ANALYZE
-                        wait_for_space = 0;
+                        ir->isr.wait_for_space = 0;
                     }
                     else
 #endif // IRMP_SUPPORT_SERIAL == 1
 
 #if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_SAMSUNG_PROTOCOL && irmp_bit == 16)       // Samsung: 16th bit
+                    if (ir->param.protocol == IRMP_SAMSUNG_PROTOCOL && ir->bit == 16)       // Samsung: 16th bit
                     {
-                        if (irmp_pulse_time >= SAMSUNG_PULSE_LEN_MIN && irmp_pulse_time <= SAMSUNG_PULSE_LEN_MAX &&
-                            irmp_pause_time >= SAMSUNG_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SAMSUNG_START_BIT_PAUSE_LEN_MAX)
+                        if (ir->isr.pulse_time >= SAMSUNG_PULSE_LEN_MIN && ir->isr.pulse_time <= SAMSUNG_PULSE_LEN_MAX &&
+                            ir->isr.pause_time >= SAMSUNG_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SAMSUNG_START_BIT_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("SYNC\n");
 #endif // ANALYZE
-                            wait_for_space = 0;
-                            irmp_bit++;
+                            ir->isr.wait_for_space = 0;
+                            ir->bit++;
                         }
-                        else  if (irmp_pulse_time >= SAMSUNG_PULSE_LEN_MIN && irmp_pulse_time <= SAMSUNG_PULSE_LEN_MAX)
+                        else  if (ir->isr.pulse_time >= SAMSUNG_PULSE_LEN_MIN && ir->isr.pulse_time <= SAMSUNG_PULSE_LEN_MAX)
                         {
 #if IRMP_SUPPORT_SAMSUNG48_PROTOCOL == 1
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("Switching to SAMSUNG48 protocol ");
 #endif // ANALYZE
-                            irmp_param.protocol         = IRMP_SAMSUNG48_PROTOCOL;
-                            irmp_param.command_offset   = SAMSUNG48_COMMAND_OFFSET;
-                            irmp_param.command_end      = SAMSUNG48_COMMAND_OFFSET + SAMSUNG48_COMMAND_LEN;
-                            irmp_param.complete_len     = SAMSUNG48_COMPLETE_DATA_LEN;
+                            ir->param.protocol         = IRMP_SAMSUNG48_PROTOCOL;
+                            ir->param.command_offset   = SAMSUNG48_COMMAND_OFFSET;
+                            ir->param.command_end      = SAMSUNG48_COMMAND_OFFSET + SAMSUNG48_COMMAND_LEN;
+                            ir->param.complete_len     = SAMSUNG48_COMPLETE_DATA_LEN;
 #else
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("Switching to SAMSUNG32 protocol ");
 #endif // ANALYZE
-                            irmp_param.protocol         = IRMP_SAMSUNG32_PROTOCOL;
-                            irmp_param.command_offset   = SAMSUNG32_COMMAND_OFFSET;
-                            irmp_param.command_end      = SAMSUNG32_COMMAND_OFFSET + SAMSUNG32_COMMAND_LEN;
-                            irmp_param.complete_len     = SAMSUNG32_COMPLETE_DATA_LEN;
+                            ir->param.protocol         = IRMP_SAMSUNG32_PROTOCOL;
+                            ir->param.command_offset   = SAMSUNG32_COMMAND_OFFSET;
+                            ir->param.command_end      = SAMSUNG32_COMMAND_OFFSET + SAMSUNG32_COMMAND_LEN;
+                            ir->param.complete_len     = SAMSUNG32_COMPLETE_DATA_LEN;
 #endif
-                            if (irmp_pause_time >= SAMSUNG_1_PAUSE_LEN_MIN && irmp_pause_time <= SAMSUNG_1_PAUSE_LEN_MAX)
+                            if (ir->isr.pause_time >= SAMSUNG_1_PAUSE_LEN_MIN && ir->isr.pause_time <= SAMSUNG_1_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PUTCHAR ('1');
                                 ANALYZE_NEWLINE ();
 #endif // ANALYZE
                                 irmp_store_bit (1);
-                                wait_for_space = 0;
+                                ir->isr.wait_for_space = 0;
                             }
                             else
                             {
@@ -4884,17 +4911,17 @@ irmp_ISR (void)
                                 ANALYZE_NEWLINE ();
 #endif // ANALYZE
                                 irmp_store_bit (0);
-                                wait_for_space = 0;
+                                ir->isr.wait_for_space = 0;
                             }
                         }
                         else
                         {                                                           // timing incorrect!
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("error 3 Samsung: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                            ANALYZE_PRINTF ("error 3 Samsung: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                             ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                            irmp_start_bit_detected = 0;                            // reset flags and wait for next start bit
-                            irmp_pause_time         = 0;
+                            ir->isr.start_bit_detected = 0;                            // reset flags and wait for next start bit
+                            ir->isr.pause_time         = 0;
                         }
                     }
                     else
@@ -4902,74 +4929,74 @@ irmp_ISR (void)
 
 #if IRMP_SUPPORT_NEC16_PROTOCOL
 #if IRMP_SUPPORT_NEC42_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_NEC42_PROTOCOL &&
+                    if (ir->param.protocol == IRMP_NEC42_PROTOCOL &&
 #else // IRMP_SUPPORT_NEC_PROTOCOL instead
-                    if (irmp_param.protocol == IRMP_NEC_PROTOCOL &&
+                    if (ir->param.protocol == IRMP_NEC_PROTOCOL &&
 #endif // IRMP_SUPPORT_NEC42_PROTOCOL == 1
-                        irmp_bit == 8 && irmp_pause_time >= NEC_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NEC_START_BIT_PAUSE_LEN_MAX)
+                        ir->bit == 8 && ir->isr.pause_time >= NEC_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NEC_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("Switching to NEC16 protocol\n");
 #endif // ANALYZE
-                        irmp_param.protocol         = IRMP_NEC16_PROTOCOL;
-                        irmp_param.address_offset   = NEC16_ADDRESS_OFFSET;
-                        irmp_param.address_end      = NEC16_ADDRESS_OFFSET + NEC16_ADDRESS_LEN;
-                        irmp_param.command_offset   = NEC16_COMMAND_OFFSET;
-                        irmp_param.command_end      = NEC16_COMMAND_OFFSET + NEC16_COMMAND_LEN;
-                        irmp_param.complete_len     = NEC16_COMPLETE_DATA_LEN;
-                        wait_for_space = 0;
+                        ir->param.protocol         = IRMP_NEC16_PROTOCOL;

+                        ir->param.address_offset   = NEC16_ADDRESS_OFFSET;
+                        ir->param.address_end      = NEC16_ADDRESS_OFFSET + NEC16_ADDRESS_LEN;
+                        ir->param.command_offset   = NEC16_COMMAND_OFFSET;
+                        ir->param.command_end      = NEC16_COMMAND_OFFSET + NEC16_COMMAND_LEN;
+                        ir->param.complete_len     = NEC16_COMPLETE_DATA_LEN;
+                        ir->isr.wait_for_space = 0;
                     }
                     else
 #endif // IRMP_SUPPORT_NEC16_PROTOCOL
 
 #if IRMP_SUPPORT_BANG_OLUFSEN_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_BANG_OLUFSEN_PROTOCOL)
+                    if (ir->param.protocol == IRMP_BANG_OLUFSEN_PROTOCOL)
                     {
-                        if (irmp_pulse_time >= BANG_OLUFSEN_PULSE_LEN_MIN && irmp_pulse_time <= BANG_OLUFSEN_PULSE_LEN_MAX)
+                        if (ir->isr.pulse_time >= BANG_OLUFSEN_PULSE_LEN_MIN && ir->isr.pulse_time <= BANG_OLUFSEN_PULSE_LEN_MAX)
                         {
-                            if (irmp_bit == 1)                                      // Bang & Olufsen: 3rd bit
+                            if (ir->bit == 1)                                      // Bang & Olufsen: 3rd bit
                             {
-                                if (irmp_pause_time >= BANG_OLUFSEN_START_BIT3_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_START_BIT3_PAUSE_LEN_MAX)
+                                if (ir->isr.pause_time >= BANG_OLUFSEN_START_BIT3_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_START_BIT3_PAUSE_LEN_MAX)
                                 {
 #ifdef ANALYZE
                                     ANALYZE_PRINTF ("3rd start bit\n");
 #endif // ANALYZE
-                                    wait_for_space = 0;
-                                    irmp_bit++;
+                                    ir->isr.wait_for_space = 0;
+                                    ir->bit++;
                                 }
                                 else
                                 {                                                   // timing incorrect!
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("error 3a B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                                    ANALYZE_PRINTF ("error 3a B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                                     ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                    irmp_start_bit_detected = 0;                    // reset flags and wait for next start bit
-                                    irmp_pause_time         = 0;
+                                    ir->isr.start_bit_detected = 0;                    // reset flags and wait for next start bit
+                                    ir->isr.pause_time         = 0;

                                 }
                             }
-                            else if (irmp_bit == 19)                                // Bang & Olufsen: trailer bit
+                            else if (ir->bit == 19)                                // Bang & Olufsen: trailer bit
                             {
-                                if (irmp_pause_time >= BANG_OLUFSEN_TRAILER_BIT_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_TRAILER_BIT_PAUSE_LEN_MAX)
+                                if (ir->isr.pause_time >= BANG_OLUFSEN_TRAILER_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_TRAILER_BIT_PAUSE_LEN_MAX)
                                 {
 #ifdef ANALYZE
                                     ANALYZE_PRINTF ("trailer bit\n");
 #endif // ANALYZE
-                                    wait_for_space = 0;
-                                    irmp_bit++;
+                                    ir->isr.wait_for_space = 0;
+                                    ir->bit++;
                                 }
                                 else
                                 {                                                   // timing incorrect!
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("error 3b B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                                    ANALYZE_PRINTF ("error 3b B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                                     ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                    irmp_start_bit_detected = 0;                    // reset flags and wait for next start bit
-                                    irmp_pause_time         = 0;
+                                    ir->isr.start_bit_detected = 0;                    // reset flags and wait for next start bit
+                                    ir->isr.pause_time         = 0;
                                 }
                             }
                             else
                             {
-                                if (irmp_pause_time >= BANG_OLUFSEN_1_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_1_PAUSE_LEN_MAX)
+                                if (ir->isr.pause_time >= BANG_OLUFSEN_1_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_1_PAUSE_LEN_MAX)
                                 {                                                   // pulse & pause timings correct for "1"?
 #ifdef ANALYZE
                                     ANALYZE_PUTCHAR ('1');
@@ -4977,9 +5004,9 @@ irmp_ISR (void)
 #endif // ANALYZE
                                     irmp_store_bit (1);
                                     last_value = 1;
-                                    wait_for_space = 0;
+                                    ir->isr.wait_for_space = 0;
                                 }
-                                else if (irmp_pause_time >= BANG_OLUFSEN_0_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_0_PAUSE_LEN_MAX)
+                                else if (ir->isr.pause_time >= BANG_OLUFSEN_0_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_0_PAUSE_LEN_MAX)
                                 {                                                   // pulse & pause timings correct for "0"?
 #ifdef ANALYZE
                                     ANALYZE_PUTCHAR ('0');
